diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTexture.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTexture.java
new file mode 100644
index 000000000..8462482f1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTexture.java
@@ -0,0 +1,129 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import net.minecraft.client.GLAllocation;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2i;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+import java.util.function.Consumer;
+
+public abstract class FrameBufferTexture implements FrameBufferAttachment {
+    private final int id;
+    private final int attachment;
+    private final @NotNull Vector2ic size;
+
+    private boolean deleted = false;
+
+    public FrameBufferTexture(final int format, final int attachment, final @NotNull Vector2ic size, final int samples, final @Nullable Consumer<@NotNull Parameters> parametersConsumer) {
+        this.id = GLAllocation.generateTexture();
+        this.attachment = attachment;
+        this.size = new Vector2i(size);
+
+        this.whileBound(() -> {
+            this.init(format, size, samples);
+            if (parametersConsumer != null) {
+                parametersConsumer.accept(new Parameters(this.getTextureTarget()));
+            }
+        });
+    }
+
+    @Override
+    public int getId() {
+        if (this.deleted) {
+            throw new IllegalStateException("Texture deleted!");
+        }
+
+        return this.id;
+    }
+
+    @Override
+    public @NotNull Vector2ic getSize() {
+        if (this.deleted) {
+            throw new IllegalStateException("Texture deleted!");
+        }
+
+        return this.size;
+    }
+
+    @Override
+    public void delete() {
+        if (this.deleted) {
+            throw new IllegalStateException("Texture already deleted!");
+        }
+
+        GLAllocation.deleteTexture(this.id);
+        this.deleted = true;
+    }
+
+    @Override
+    public boolean isDeleted() {
+        return this.deleted;
+    }
+
+    @Override
+    public void whileBound(final @NotNull Runnable runnable) {
+        if (this.deleted) {
+            throw new IllegalStateException("Texture deleted!");
+        }
+
+        GL41.glBindTexture(this.getTextureTarget(), this.id);
+        runnable.run();
+        GL41.glBindTexture(this.getTextureTarget(), 0);
+    }
+
+    @Override
+    public void attachToFramebuffer(final @NotNull FrameBuffer frameBuffer) {
+        frameBuffer.whileBound(() -> {
+            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, this.attachment, this.getTextureTarget(), this.getId(), 0);
+        });
+    }
+
+    @Override
+    public int getAttachment() {
+        return this.attachment;
+    }
+
+    @Override
+    public void bindForOutput() {
+        GL41.glBindTexture(this.getTextureTarget(), this.id);
+    }
+
+    @Override
+    public void unbindForOutput() {
+        GL41.glBindTexture(this.getTextureTarget(), 0);
+    }
+
+    protected abstract void init(final int format, final @NotNull Vector2ic size, final int samples);
+
+    protected abstract int getTextureTarget();
+
+    public static final class Parameters {
+        private final int textureTarget;
+
+        private Parameters(final int textureTarget) {
+            this.textureTarget = textureTarget;
+        }
+
+        public @NotNull Parameters set(final int parameter, final int value) {
+            GL41.glTexParameteri(this.textureTarget, parameter, value);
+            return this;
+        }
+
+        public @NotNull Parameters set(final int parameter, final float value) {
+            GL41.glTexParameterf(this.textureTarget, parameter, value);
+            return this;
+        }
+
+        public @NotNull Parameters set(final int parameter, final int @NotNull ... values) {
+            GL41.glTexParameteriv(this.textureTarget, parameter, values);
+            return this;
+        }
+
+        public @NotNull Parameters set(final int parameter, final float @NotNull ... values) {
+            GL41.glTexParameterfv(this.textureTarget, parameter, values);
+            return this;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureMultiSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureMultiSample.java
new file mode 100644
index 000000000..922cb7567
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureMultiSample.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+import java.util.function.Consumer;
+
+public class FrameBufferTextureMultiSample extends FrameBufferTexture implements FrameBufferAttachmentMultiSample {
+    public FrameBufferTextureMultiSample(final int format, final int attachment, final @NotNull Vector2ic size, final int samples) {
+        super(format, attachment, size, samples, null);
+    }
+
+    @Override
+    protected void init(final int format, final @NotNull Vector2ic size, final int samples) {
+        GL41.glTexImage2DMultisample(this.getTextureTarget(), samples, format, size.x(), size.y(), true);
+    }
+
+    @Override
+    protected int getTextureTarget() {
+        return GL41.GL_TEXTURE_2D_MULTISAMPLE;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureSingleSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureSingleSample.java
new file mode 100644
index 000000000..5f725c522
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferTextureSingleSample.java
@@ -0,0 +1,33 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+import java.util.function.Consumer;
+
+public class FrameBufferTextureSingleSample extends FrameBufferTexture implements FrameBufferAttachmentSingleSample {
+    public FrameBufferTextureSingleSample(final int format, final int attachment, final @NotNull Vector2ic size, final @Nullable Consumer<@NotNull Parameters> parametersConsumer) {
+        super(format, attachment, size, 0, parametersConsumer);
+    }
+
+    @Override
+    protected void init(final int format, final @NotNull Vector2ic size, final int samples) {
+        final int type;
+        if (format == GL41.GL_DEPTH24_STENCIL8) {
+            type = GL41.GL_UNSIGNED_INT;
+        } else if (format == GL41.GL_DEPTH_COMPONENT) {
+            type = GL41.GL_FLOAT;
+        } else {
+            type = GL41.GL_UNSIGNED_BYTE;
+        }
+
+        GL41.glTexImage2D(this.getTextureTarget(), 0, format, size.x(), size.y(), 0, format, type, 0);
+    }
+
+    @Override
+    protected int getTextureTarget() {
+        return GL41.GL_TEXTURE_2D;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBuffer.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBuffer.java
new file mode 100644
index 000000000..8897a32d7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBuffer.java
@@ -0,0 +1,91 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+public abstract class RenderBuffer implements FrameBufferAttachment {
+    private final int id;
+    private final int attachment;
+    private final @NotNull Vector2ic size;
+
+    private boolean deleted = false;
+
+    public RenderBuffer(final int format, final int attachment, final @NotNull Vector2ic size, final int samples) {
+        this.id = GL41.glGenRenderbuffers();
+        this.attachment = attachment;
+        this.size = size;
+
+        this.whileBound(() -> {
+            this.init(format, size, samples);
+        });
+    }
+
+    @Override
+    public int getId() {
+        if (this.deleted) {
+            throw new IllegalStateException("Render buffer deleted!");
+        }
+
+        return this.id;
+    }
+
+    @Override
+    public @NotNull Vector2ic getSize() {
+        if (this.deleted) {
+            throw new IllegalStateException("Render buffer deleted!");
+        }
+
+        return this.size;
+    }
+
+    @Override
+    public void delete() {
+        if (this.deleted) {
+            throw new IllegalStateException("Render buffer already deleted!");
+        }
+
+        GL41.glDeleteRenderbuffers(this.id);
+        this.deleted = true;
+    }
+
+    @Override
+    public boolean isDeleted() {
+        return this.deleted;
+    }
+
+    @Override
+    public void whileBound(final @NotNull Runnable runnable) {
+        if (this.deleted) {
+            throw new IllegalStateException("Render buffer deleted!");
+        }
+
+        GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, this.id);
+        runnable.run();
+        GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, 0);
+    }
+
+    @Override
+    public void attachToFramebuffer(final @NotNull FrameBuffer frameBuffer) {
+        frameBuffer.whileBound(() -> {
+            GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, this.attachment, GL41.GL_RENDERBUFFER, this.id);
+        });
+    }
+
+    @Override
+    public int getAttachment() {
+        return this.attachment;
+    }
+
+    @Override
+    public void bindForOutput() {
+        throw new IllegalStateException("Render buffers cannot be bound for output!");
+    }
+
+    @Override
+    public void unbindForOutput() {
+        throw new IllegalStateException("Render buffers cannot be unbound for output!");
+    }
+
+    protected abstract void init(final int format, final @NotNull Vector2ic size, final int samples);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferMultiSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferMultiSample.java
new file mode 100644
index 000000000..73a2edf95
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferMultiSample.java
@@ -0,0 +1,16 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+public class RenderBufferMultiSample extends RenderBuffer implements FrameBufferAttachmentMultiSample {
+    public RenderBufferMultiSample(final int format, final int attachment, final @NotNull Vector2ic size, final int samples) {
+        super(format, attachment, size, samples);
+    }
+
+    @Override
+    protected void init(final int format, final @NotNull Vector2ic size, final int samples) {
+        GL41.glRenderbufferStorageMultisample(GL41.GL_RENDERBUFFER, samples, format, size.x(), size.y());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferSingleSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferSingleSample.java
new file mode 100644
index 000000000..d28464352
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/RenderBufferSingleSample.java
@@ -0,0 +1,16 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+public class RenderBufferSingleSample extends RenderBuffer implements FrameBufferAttachmentSingleSample {
+    public RenderBufferSingleSample(final int format, final int attachment, final @NotNull Vector2ic size) {
+        super(format, attachment, size, 0);
+    }
+
+    @Override
+    protected void init(final int format, final @NotNull Vector2ic size, final int samples) {
+        GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, format, size.x(), size.y());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index 1be432f97..a5105ba62 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -12,6 +12,7 @@ import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.render.texture.meta.TextureProperties;
 import net.minecraft.client.util.helper.Buffer;
 import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 import java.awt.image.BufferedImage;
@@ -40,6 +41,10 @@ public class Texture {
 		return metaDefault;
 	}
 
+	public int getTextureType() {
+		return GL_TEXTURE_2D;
+	}
+
 	public boolean generate() {
 		if(isGenerated()) {
 			return false;
@@ -67,12 +72,12 @@ public class Texture {
 			return false;
 		}
 		
-		glBindTexture(GL_TEXTURE_2D, this.id);
+		glBindTexture(this.getTextureType(), this.id);
 		return true;
 	}
 
 	public void unbind() {
-		glBindTexture(GL_TEXTURE_2D, 0);
+		glBindTexture(this.getTextureType(), 0);
 	}
 
 	// TODO we CANNOT rely on this, especially as thing become more multithreaded this just destroys the game
@@ -87,11 +92,11 @@ public class Texture {
 	}
 	
 	public int getWidth() {
-		return glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
+		return glGetTexLevelParameteri(this.getTextureType(), 0, GL_TEXTURE_WIDTH);
 	}
 	
 	public int getHeight() {
-		return glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
+		return glGetTexLevelParameteri(this.getTextureType(), 0, GL_TEXTURE_HEIGHT);
 	}
 	
 	public int id() {
@@ -113,29 +118,31 @@ public class Texture {
 	}
 
 	public void setupTexture(BufferedImage img, boolean blurTexture, boolean clampTexture, boolean mipmap) {
+		assert this.getTextureType() == GL_TEXTURE_2D;
+
 		bind();
 
 		if(blurTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 		}else {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_MAG_FILTER, GL_NEAREST);
 		}
 
 		if(clampTexture) {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
 		}else {
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
-			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_WRAP_S, GL_REPEAT);
+			glTexParameteri(this.getTextureType(), GL_TEXTURE_WRAP_T, GL_REPEAT);
 		}
 
 		int w = img.getWidth();
 		int h = img.getHeight();
 
 		Buffer.put(img);
-		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+		glTexImage2D(this.getTextureType(), 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 
 		if(mipmap) {
 			generateMipmaps(buffer, img, GameSettings.MIPMAP_LEVELS.value, GameSettings.MIPMAP_TYPE.value == MipmapType.SMOOTH);
@@ -143,6 +150,8 @@ public class Texture {
 	}
 
 	protected void generateMipmaps(ByteBuffer buffer, BufferedImage image, int levels, boolean smooth) {
+		assert this.getTextureType() == GL_TEXTURE_2D;
+
 		LOGGER.info("Generating Mipmaps...");
 
 		final int width = image.getWidth();
@@ -250,10 +259,10 @@ public class Texture {
 
 			buffer.limit(buffer.position()).flip();
 
-			glTexImage2D(GL_TEXTURE_2D, debugMipmap ? 0 : level, GL_RGBA, newWidth, newHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+			glTexImage2D(this.getTextureType(), debugMipmap ? 0 : level, GL_RGBA, newWidth, newHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 			if(!debugMipmap) {
-				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, level);
-				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
+				glTexParameteri(this.getTextureType(), GL_TEXTURE_MAX_LEVEL, level);
+				glTexParameteri(this.getTextureType(), GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
 			}
 
 			data = newData;
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/TextureMultisampled.java b/game/client/src/main/java/net/minecraft/client/render/texture/TextureMultisampled.java
new file mode 100644
index 000000000..8f853e59f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/TextureMultisampled.java
@@ -0,0 +1,10 @@
+package net.minecraft.client.render.texture;
+
+import org.lwjgl.opengl.GL41;
+
+public class TextureMultisampled extends Texture {
+    @Override
+    public int getTextureType() {
+        return GL41.GL_TEXTURE_2D_MULTISAMPLE;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
index c26e31e08..2feb5149a 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
@@ -1,12 +1,20 @@
 package net.minecraft.client.util.helper;
 
 import java.io.File;
+import java.nio.ByteBuffer;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Date;
+import java.util.Objects;
+import java.util.function.Supplier;
 
 import com.mojang.logging.LogUtils;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.shader.ShadersRenderer;
+import net.minecraft.client.render.shader.framebuffer.FrameBuffer;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL41;
 import org.lwjgl.stb.STBImageWrite;
 import org.lwjgl.system.MemoryUtil;
@@ -17,50 +25,125 @@ public class ScreenShot
     private static final Logger LOGGER = LogUtils.getLogger();
     private static final DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss");
 
-    public static String saveScreenshot(File mcDir, int width, int height)
-    {
-        try
-        {
-            File screenshotsDir = new File(mcDir, "screenshots");
+    private static int transferPbo = -1;
+    private static int pboWidth = -1;
+    private static int pboHeight = -1;
+
+    private static long fence = -1;
+    private static @Nullable File destFile = null;
+
+    public static void saveScreenshot(Minecraft mc, File mcDir, int width, int height) {
+        // Cancel if already screenshotting
+        if (fence >= 0) {
+            return;
+        }
+
+        // Recreate PBO if needed
+        if (transferPbo < 0 || width != pboWidth || height != pboHeight) {
+            pboWidth = width;
+            pboHeight = height;
+
+            if (transferPbo >= 0) {
+                GL41.glDeleteBuffers(transferPbo);
+            }
+
+            transferPbo = GL41.glGenBuffers();
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, transferPbo);
+            GL41.glBufferData(GL41.GL_PIXEL_PACK_BUFFER, pboWidth * pboHeight * 4L, GL41.GL_STATIC_READ);
+
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, 0);
+        }
+
+        try {
+            final @NotNull File screenshotsDir = new File(mcDir, "screenshots");
             //noinspection ResultOfMethodCallIgnored
             screenshotsDir.mkdir();
 
-            String dateString = dateFormat.format(new Date());
-            File destFile;
+            final @NotNull String dateString = dateFormat.format(new Date());
             int id = 1;
             while ((destFile = new File(screenshotsDir, dateString + (id != 1 ? "_" + id : "") + ".png")).exists()) {
                 id++;
             }
 
-            var buffer1 = MemoryUtil.memCalloc(width * height * 3);
-            var buffer2 = MemoryUtil.memCalloc(width * height * 3);
+            final @Nullable FrameBuffer frameBuffer = ((ShadersRenderer) mc.renderer).getGameFrameBuffer();
+            if (frameBuffer == null) {
+                throw new IllegalStateException("Game frame buffer is null!");
+            }
+
+            // Bind framebuffer and PBO
+            frameBuffer.bind();
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, transferPbo);
+
+            // Insert fence
+            fence = GL41.glFenceSync(GL41.GL_SYNC_GPU_COMMANDS_COMPLETE, 0);
+
+            // Copy from FBO to PBO (asynchronous, returns immediately)
             GL41.glPixelStorei(GL41.GL_PACK_ALIGNMENT, 1);
             GL41.glPixelStorei(GL41.GL_UNPACK_ALIGNMENT, 1);
-            GL41.glReadPixels(0, 0, width, height, GL41.GL_RGB, GL41.GL_UNSIGNED_BYTE, buffer1);
+            GL41.glReadPixels(0, 0, width, height, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
+
+            // Unbind framebuffer and PBO
+            frameBuffer.unbind();
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, 0);
 
-            for (int y = 0; y < height; y++) { // Flip image vertically
-                int index = y * width * 3;
-                buffer2.put(index, buffer1, height * width * 3 - (y + 1) * width * 3, width * 3);
+        } catch(Exception exception) {
+            LOGGER.error("Failed to save screenshot!", exception);
+        }
+    }
+
+    public static @Nullable String tickScreenShot() {
+        if (fence < 0) {
+            return null;
+        }
+
+        // Test fence result (returns immediately)
+        final int syncResult = GL41.glClientWaitSync(fence, 0, 0);
+        if (syncResult == GL41.GL_ALREADY_SIGNALED || syncResult == GL41.GL_CONDITION_SATISFIED) {
+            GL41.glDeleteSync(fence);
+            fence = -1;
+
+            // Bind PBO
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, transferPbo);
+
+            // Map PBO
+            final @NotNull ByteBuffer pboBuffer = Objects.requireNonNull(GL41.glMapBuffer(GL41.GL_PIXEL_PACK_BUFFER, GL41.GL_READ_ONLY));
+
+            // Create flipped buffer
+            final @NotNull ByteBuffer flipBuffer = MemoryUtil.memCalloc(pboWidth * pboHeight * 4);
+            for (int y = 0; y < pboHeight; y++) { // Flip image vertically
+                final int index = y * pboWidth * 4;
+                flipBuffer.put(index, pboBuffer, pboHeight * pboWidth * 4 - (y + 1) * pboWidth * 4, pboWidth * 4);
+            }
+
+            if (!STBImageWrite.stbi_write_png(destFile.getAbsolutePath(), pboWidth, pboHeight, 4, flipBuffer, pboWidth * 4)) {
+                LOGGER.error("Failed to save screenshot!");
+                return "Failed to save screenshot.";
             }
 
-            STBImageWrite.stbi_write_png(destFile.getAbsolutePath(), width, height, 3, buffer2, width * 3);
+            // Free flip buffer
+            MemoryUtil.memFree(flipBuffer);
+
+            // Unmap PBO
+            GL41.glUnmapBuffer(GL41.GL_PIXEL_PACK_BUFFER);
 
-            MemoryUtil.memFree(buffer1);
-            MemoryUtil.memFree(buffer2);
+            // Unbind PBO
+            GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, 0);
 
             try {
-                boolean copiedImage = FileOpener.toClipboard(destFile.getAbsolutePath());
+                final boolean copiedImage = FileOpener.toClipboard(destFile.getAbsolutePath());
                 if (copiedImage) {
                     return "Saved screenshot as " + destFile.getName() + " and copied to clipboard.";
                 }
-            } catch (Exception ignored) {}
-            return "Saved screenshot as " + destFile.getName();
-        }
-        catch(Exception exception)
-        {
-            LOGGER.error("Failed to save screenshot!", exception);
-            return "Failed to save: " + exception;
+            } catch (final @NotNull Exception e) {
+                return "Saved screenshot as " + destFile.getName();
+            }
+        } else if (syncResult == GL41.GL_WAIT_FAILED) {
+            GL41.glDeleteSync(fence);
+            fence = -1;
+
+            throw new IllegalStateException("PBO sync wait failed!");
         }
-    }
 
+        return null;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index add22177d..20f665cac 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -102,7 +102,7 @@ public class WorldClient extends World {
         float r = (float) (color >> 16 & 255) / 255F;
         float g = (float) (color >> 8 & 255) / 255F;
         float b = (float) (color & 255) / 255F;
-        float f6 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? this.weatherManager.getWeatherIntensity() * this.weatherManager.getWeatherPower() : 0.0f;
+        float f6 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? this.getWeatherManager().getWeatherIntensity() * this.getWeatherManager().getWeatherPower() : 0.0f;
         if (f6 > 0.0F) {
             float f7 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
             float f9 = 1.0F - f6 * 0.95F;
@@ -136,7 +136,7 @@ public class WorldClient extends World {
         TilePos blockPos = camera.getTilePos(partialTick);
         float blockTemperature = (float) getBlockTemperature(blockPos);
 
-        if (this.seasonManager.getCurrentSeason() != null && (this.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER || this.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
+        if (this.getSeasonManager().getCurrentSeason() != null && (this.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || this.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
             blockTemperature = blockTemperature - (1.25f);
         }
         int skyColor;
@@ -151,7 +151,7 @@ public class WorldClient extends World {
         r *= f2;
         g *= f2;
         b *= f2;
-        float f7 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? this.weatherManager.getWeatherIntensity() * this.weatherManager.getWeatherPower() : 0.0f;
+        float f7 = getCurrentWeather() != null && getCurrentWeather() instanceof IPrecipitation ? this.getWeatherManager().getWeatherIntensity() * this.getWeatherManager().getWeatherPower() : 0.0f;
         if (f7 > 0.0F) {
             float f8 = (r * 0.3F + g * 0.59F + b * 0.11F) * 0.6F;
             float f10 = 1.0F - f7 * 0.75F;
@@ -160,7 +160,7 @@ public class WorldClient extends World {
             b = b * f10 + f8 * (1.0F - f10);
         }
 
-        float fogIntensity = getCurrentWeather() != null && getCurrentWeather() == Weathers.OVERWORLD_FOG ? this.weatherManager.getWeatherIntensity() * this.weatherManager.getWeatherPower() : 0.0f;
+        float fogIntensity = getCurrentWeather() != null && getCurrentWeather() == Weathers.OVERWORLD_FOG ? this.getWeatherManager().getWeatherIntensity() * this.getWeatherManager().getWeatherPower() : 0.0f;
         if (fogIntensity > 0.0F) {
             float f8 = (r * 0.5F + g * 0.5F + b * 0.5F) * 0.6F;
             float f10 = 1.0F - fogIntensity * 0.75F;
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 594e0819a..6087bb80a 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -1,6 +1,7 @@
 package org.useless.dragonfly.models.block.mojang;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
@@ -231,7 +232,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     }
                 }
 
-                final boolean useAO = this.compiled.data.ambientOcclusion && MC.isAmbientOcclusionEnabled() && element.shade;
+                final boolean useAO = this.compiled.data.ambientOcclusion && GameSettings.AMBIENT_OCCLUSION.value && element.shade;
                 final boolean isFullCube = depth <= FULL_CUBE_THRESHOLD && element.shade;
 
                 final float r;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index c1a5d656f..0d0d425ec 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -75,7 +75,7 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
             float f = calcBrightness(1.0F);
             Weather weather;
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                && (weather = world.getCurrentWeather()) != null &&  !weather.isDamp() && (weather != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.8F))
+                && (weather = world.getCurrentWeather()) != null &&  !weather.isDamp() && (weather != Weathers.OVERWORLD_FOG || world.getWeatherManager().getWeatherPower() < 0.8F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
index f31482606..0dec555e9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
@@ -33,7 +33,7 @@ public class MobSnowman extends MobMonster
         {
             float f = calcBrightness(1.0F);
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                    && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F) && world.getCurrentWeather() != Weathers.OVERWORLD_SNOW && world.getCurrentWeather() != Weathers.OVERWORLD_WINTER_SNOW)
+                    && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.getWeatherManager().getWeatherPower() < 0.75F) && world.getCurrentWeather() != Weathers.OVERWORLD_SNOW && world.getCurrentWeather() != Weathers.OVERWORLD_WINTER_SNOW)
             {
                 remainingFireTicks = 300;
             }
